//
//  PageControlRootViewController.m
//  bcrfa01
//
//  Created by A M on 11-12-31.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "PageControlRootViewController.h"
#import "ModelController.h"

#import "webOrpdfViewController.h"
//==============================================================================
@interface PageControlRootViewController ()
@property (readonly, strong, nonatomic) ModelController *modelController;

@end

//==============================================================================
@implementation PageControlRootViewController

@synthesize pageViewController = _pageViewController;
@synthesize modelController = _modelController;
@synthesize callingButton = _callingButton;
//==============================================================================
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    
    NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
    
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) 
    {
        // Custom initialization
    }
    return self;
}
//==============================================================================
- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}
//==============================================================================
#pragma mark - View lifecycle
-(void)viewWillAppear:(BOOL)animated
{
    NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
    [self.modelController setDataModelFor:self.callingButton];
}

//==============================================================================
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);      
    // Configure the page view controller and add it as a child view controller.
    self.pageViewController = [[UIPageViewController alloc] 
                               initWithTransitionStyle:UIPageViewControllerTransitionStylePageCurl 
                               navigationOrientation:UIPageViewControllerNavigationOrientationHorizontal 
                               options:nil];
    self.pageViewController.delegate = self;
    
    NSLog(@"PageViewController says the calling button tag is %d", self.callingButton.tag);
    
    [self.modelController setDataModelFor:self.callingButton];
    
    webOrpdfViewController *beginningController = [self.modelController 
                                                   viewControllerAtIndex:0 
                                                   storyboard:self.storyboard];
       
    NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
    
    
    NSArray *viewControllers = [NSArray arrayWithObject: beginningController];
    [self.pageViewController setViewControllers:viewControllers 
                                      direction:UIPageViewControllerNavigationDirectionForward 
                                       animated:NO 
                                     completion:NULL];
    
    self.pageViewController.dataSource = self.modelController;
  
    NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
    [self addChildViewController:self.pageViewController];
    [self.view addSubview:self.pageViewController.view];
    
        // Set the page view controller's bounds using an inset rect so that self's view is visible around the edges of the pages.
    CGRect pageViewRect = self.view.bounds;
    /*
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
        pageViewRect = CGRectInset(pageViewRect, 40.0, 40.0);
    }
     */
    self.pageViewController.view.frame = pageViewRect;
    
    [self.pageViewController didMoveToParentViewController:self];    
    
        // Add the page view controller's gesture recognizers to the book view controller's view so that the gestures are started more easily.
    self.view.gestureRecognizers = self.pageViewController.gestureRecognizers;

     NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
    
}
//==============================================================================
-(void)viewWillDisappear:(BOOL)animated
{
    self.hidesBottomBarWhenPushed = NO;

}
//==============================================================================
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}
//==============================================================================
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    //return (interfaceOrientation == UIInterfaceOrientationPortrait);
    return NO;
    
}
//==============================================================================
- (ModelController *)modelController
{
    
    
    if (!_modelController) 
    {
        NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
       _modelController = [ModelController getSingleton];
    }
    
    [_modelController setDataModelFor:self.callingButton];
    NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
    return _modelController;
}

//==============================================================================
#pragma mark - UIPageViewController delegate methods

/*
 - (void)pageViewController:(UIPageViewController *)pageViewController didFinishAnimating:(BOOL)finished previousViewControllers:(NSArray *)previousViewControllers transitionCompleted:(BOOL)completed
 {
 
 }
 */
//==============================================================================
- (UIPageViewControllerSpineLocation)pageViewController:(UIPageViewController *)pageViewController spineLocationForInterfaceOrientation:(UIInterfaceOrientation)orientation
{
        //if (UIInterfaceOrientationIsPortrait(orientation) || ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone)) 
    {
            // In portrait orientation or on iPhone: Set the spine position to "min" and the page view controller's view controllers array to contain just one view controller. Setting the spine position to 'UIPageViewControllerSpineLocationMid' in landscape orientation sets the doubleSided property to YES, so set it to NO here.
        
        
        UIViewController *currentViewController = [self.pageViewController.viewControllers objectAtIndex:0];
        NSArray *viewControllers = [NSArray arrayWithObject:currentViewController];
        [self.pageViewController setViewControllers:viewControllers 
                                          direction:UIPageViewControllerNavigationDirectionForward 
                                           animated:YES completion:NULL];
        
        self.pageViewController.doubleSided = NO;
        
         NSLog(@"%s %d %s", __FILE__, __LINE__, __PRETTY_FUNCTION__);
        return UIPageViewControllerSpineLocationMin;
    }
   
    /*
    {
        // In landscape orientation: Set set the spine location to "mid" and the page view controller's view controllers array to contain two view controllers. If the current page is even, set it to contain the current and next view controllers; if it is odd, set the array to contain the previous and current view controllers.
    DataViewController *currentViewController = [self.pageViewController.viewControllers objectAtIndex:0];
    NSArray *viewControllers = nil;
    
    NSUInteger indexOfCurrentViewController = [self.modelController indexOfViewController:currentViewController];
    if (indexOfCurrentViewController == 0 || indexOfCurrentViewController % 2 == 0) {
        UIViewController *nextViewController = [self.modelController pageViewController:self.pageViewController viewControllerAfterViewController:currentViewController];
        viewControllers = [NSArray arrayWithObjects:currentViewController, nextViewController, nil];
    } else {
        UIViewController *previousViewController = [self.modelController pageViewController:self.pageViewController viewControllerBeforeViewController:currentViewController];
        viewControllers = [NSArray arrayWithObjects:previousViewController, currentViewController, nil];
    }
    [self.pageViewController setViewControllers:viewControllers direction:UIPageViewControllerNavigationDirectionForward animated:YES completion:NULL];
    
    
    return UIPageViewControllerSpineLocationMid;
    }
     */
}

 //==============================================================================




@end
